> For the complete documentation index, see [llms.txt](https://docs.pinot.apache.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pinot.apache.org/functions/aggregation/idset.md).

# IDSET

Returns a serialized IdSet representing the set of distinct values for a column. The IdSet can be backed by a RoaringBitmap (for INT columns), Roaring64NavigableMap (for LONG columns), or BloomFilter (for other types). The serialized IdSet is useful with the `IN_ID_SET` filter for efficient precomputed filtering.

Optional parameters can configure the IdSet type and properties.

## Signature

> IDSET(colName)
>
> IDSET(colName, 'parameters')

Supported parameters (semicolon-separated):

| Parameter              | Description                                   | Default |
| ---------------------- | --------------------------------------------- | ------- |
| `sizeThresholdInBytes` | Maximum size before switching to BloomFilter  | 8MB     |
| `expectedInsertions`   | Expected number of insertions for BloomFilter | 5000000 |
| `fpp`                  | False positive probability for BloomFilter    | 0.03    |

## Usage Examples

These examples are based on the [Batch Quick Start](/start-here/quick-start.md#batch-processing).

```sql
select IDSET(playerID) AS value
from baseballStats
WHERE yearID = 2000
```

```sql
select IDSET(playerID, 'sizeThresholdInBytes=1048576;expectedInsertions=5000000;fpp=0.03') AS value
from baseballStats
```

The resulting IdSet can be used in subsequent queries:

```sql
select playerName
from baseballStats
WHERE IN_ID_SET(playerID, '<base64-encoded-idset>') = 1
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.pinot.apache.org/functions/aggregation/idset.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
